function [ datastruct ] = LogFileParser( logfilename,location )
%LOGFILEPARSER parses the paparazzi autopilot log file
%   The log file parser 
if nargin<2, location = fullfile('~','paparazzi','var','logs');end
fid = fopen(fullfile(location,logfilename));
if fid == -1
    display('Error in opening the file! ');
    display('Please modify the script to give pprz log file name and directory.');
    return
end

datastruct.PONG = 1;
while ~feof(fid)
    tline = fgetl(fid);
    if strfind(tline,'ATTITUDE')
        ATTITUDE = cell2mat(textscan(tline,'%f %*d %*s %f %f %f',1));
        if isfield(datastruct,'ATTITUDE')
            datastruct.ATTITUDE = [datastruct.ATTITUDE;ATTITUDE];
        else
            datastruct.ATTITUDE = ATTITUDE;
        end    
    elseif strfind(tline,'BAT')
        BAT= cell2mat(textscan(tline,'%f %*d %*s %f %f %f %f %f %f %f %f',1));
        if isfield(datastruct,'BAT')
            datastruct.BAT = [datastruct.BAT;BAT];
        else
            datastruct.BAT = BAT;
        end
        
    elseif strfind(tline,'CALIBRATION')
        CALIBRATION= cell2mat(textscan(tline,'%f %*d %*s %f %f',1));
        if isfield(datastruct,'CALIBRATION')
            datastruct.CALIBRATION = [datastruct.CALIBRATION;CALIBRATION];
        else
            datastruct.CALIBRATION = CALIBRATION;
        end
        
    elseif strfind(tline,'CIRCLE')
        CIRCLE= cell2mat(textscan(tline,'%f %*d %*s %f %f %f',1));
        if isfield(datastruct,'CIRCLE')
            datastruct.CIRCLE = [datastruct.CIRCLE;CIRCLE];
        else
           datastruct.CIRCLE = CIRCLE;
        end 
        
    elseif strfind(tline,'DOWNLINK_STATUS')
        DOWNLINK_STATUS = cell2mat(textscan(tline,'%f %*d %*s %f %f %f %f %f %f %f',1));
        if isfield(datastruct,'DOWNLINK_STATUS')
            datastruct.DOWNLINK_STATUS = [datastruct.DOWNLINK_STATUS;DOWNLINK_STATUS];
        else
            datastruct.DOWNLINK_STATUS = DOWNLINK_STATUS;
        end 
            

    elseif strfind(tline,'DESIRED')
        DESIRED= cell2mat(textscan(tline,'%f %*d %*s %f %f %f %f %f %f %f',1));
        if isfield(datastruct,'DESIRED')
            datastruct.DESIRED = [datastruct.DESIRED;DESIRED];
        else
            datastruct.DESIRED = DESIRED;
        end
        
    elseif strfind(tline,'DL_VALUE')
        DL_VALUE= cell2mat(textscan(tline,'%f %*d %*s %f %f',1));
        if isfield(datastruct,'DL_VALUE')
            datastruct.DL_VALUE = [datastruct.DL_VALUE;DL_VALUE];
        else
            datastruct.DL_VALUE = DL_VALUE;
        end
        
    elseif ~isempty(strfind(tline,'DOWNLINK'))&& isempty(strfind(tline,'STATUS'))
        DOWNLINK= cell2mat(textscan(tline,'%f %*d %*s %f %f %f',1));
        if isfield(datastruct,'DOWNLINK')
            datastruct.DOWNLINK = [datastruct.DOWNLINK;DOWNLINK];
        else
            datastruct.DOWNLINK = DOWNLINK;
        end 
        
    elseif strfind(tline,'ESTIMATOR')
        ESTIMATOR = cell2mat(textscan(tline,'%f %*d %*s %f %f',1));
        if isfield(datastruct,'ESTIMATOR')
            datastruct.ESTIMATOR = [datastruct.ESTIMATOR;ESTIMATOR];
        else
            datastruct.ESTIMATOR = ESTIMATOR;
        end

    elseif strfind(tline,'ENERGY')
        ENERGY= cell2mat(textscan(tline,'%f %*d %*s %f %f %f %f',1));
        if isfield(datastruct,'ENERGY')
            datastruct.ENERGY = [datastruct.ENERGY;ENERGY];
        else
            datastruct.ENERGY = ENERGY;
        end         
        
    elseif strfind(tline,'FBW_STATUS')
        FBW_STATUS= cell2mat(textscan(tline,'%f %*d %*s %f %f %f %f %f',1));
        if isfield(datastruct,'FBW_STATUS')
            datastruct.FBW_STATUS = [datastruct.FBW_STATUS;FBW_STATUS];
        else
            datastruct.FBW_STATUS = FBW_STATUS;
        end 
        
    elseif ~isempty(strfind(tline,'GPS'))&& isempty(strfind(tline,'SOL'))
        GPS= cell2mat(textscan(tline,'%f %*d %*s %f %f %f %f %f %f %f %f %f %f %f',1));
        if isfield(datastruct,'GPS')
            datastruct.GPS = [datastruct.GPS;GPS];
        else
            datastruct.GPS = GPS;
        end
        
    elseif ~isempty(strfind(tline,'GPS'))&& ~isempty(strfind(tline,'SOL'))
        GPS_SOL= cell2mat(textscan(tline,'%f %*d %*s %f %f %f %f',1));
        if isfield(datastruct,'GPS_SOL')
            datastruct.GPS_SOL = [datastruct.GPS_SOL;GPS_SOL];
        else
            datastruct.GPS_SOL = GPS_SOL;
        end 
        
    elseif strfind(tline,'IR_SENSORS')
        IR_SENSORS= cell2mat(textscan(tline,'%f %*d %*s %f %f %f %f %f',1));
        if isfield(datastruct,'IR_SENSORS')
            datastruct.IR_SENSORS = [datastruct.IR_SENSORS;IR_SENSORS];
        else
            datastruct.IR_SENSORS = IR_SENSORS;
        end
        
    elseif strfind(tline,'MOVE_WP')
        MOVE_WP= cell2mat(textscan(tline,'%f %*d %*s %f',1));
        if isfield(datastruct,'MOVE_WP')
            datastruct.MOVE_WP = [datastruct.MOVE_WP;MOVE_WP];
        else
           datastruct.MOVE_WP = MOVE_WP;
        end        
        
    elseif ~isempty(strfind(tline,'NAVIGATION'))&& isempty(strfind(tline,'REF'))
        NAVIGATION= cell2mat(textscan(tline,'%f %*d %*s %f %f %f %f %f %f %f %f',1));
        if isfield(datastruct,'NAVIGATION')
            datastruct.NAVIGATION = [datastruct.NAVIGATION;NAVIGATION];
        else
            datastruct.NAVIGATION = NAVIGATION;
        end
        
    elseif strfind(tline,'PPRZ_MODE')
        PPRZ_MODE= cell2mat(textscan(tline,'%f %*d %*s  %f %f %f %f %f %f',1));
        if isfield(datastruct,'PPRZ_MODE')
            datastruct.PPRZ_MODE = [datastruct.PPRZ_MODE;PPRZ_MODE];
        else
            datastruct.PPRZ_MODE = PPRZ_MODE;
        end
        
    elseif strfind(tline,'STATE_FILTER_STATUS')
        STATE_FILTER_STATUS = cell2mat(textscan(tline,'%f %*d %*s %f %f',1));
        if isfield(datastruct,'STATE_FILTER_STATUS')
            datastruct.STATE_FILTER_STATUS = [datastruct.STATE_FILTER_STATUS;STATE_FILTER_STATUS];
        else
            datastruct.STATE_FILTER_STATUS = STATE_FILTER_STATUS;
        end
        
    elseif strfind(tline,'SEGMENT')
        SEGMENT= cell2mat(textscan(tline,'%f %*d %*s %f %f %f %f',1));
        if isfield(datastruct,'SEGMENT')
            datastruct.SEGMENT = [datastruct.SEGMENT;SEGMENT];
        else
           datastruct.SEGMENT = SEGMENT;
        end            
    elseif ~isempty(strfind(tline,'SETTING'))&& isempty(strfind(tline,'GET'))
        SETTING= cell2mat(textscan(tline,'%f %*d %*s %f %f %f',1));
        if isfield(datastruct,'SETTING')
            datastruct.SETTING = [datastruct.SETTING;SETTING];
        else
           datastruct.SETTING = SETTING;
        end 
        
    elseif strfind(tline,'SVINFO')
        SVINFO= cell2mat(textscan(tline,'%f %*d %*s %f %f %f %f %f %f %f',1));
        if isfield(datastruct,'SVINFO')
            datastruct.SVINFO = [datastruct.SVINFO;SVINFO];
        else
            datastruct.SVINFO = SVINFO;
        end
        
    elseif strfind(tline,'SYS_MON')
        SYS_MON = cell2mat(textscan(tline,'%f %*d %*s %f %f %f %f %f %f',1));
        if isfield(datastruct,'SYS_MON')
            datastruct.SYS_MON = [datastruct.SYS_MON;SYS_MON];
        else
            datastruct.SYS_MON = SYS_MON;
        end  
        
    elseif strfind(tline,'TAKEOFF')
        TAKEOFF= cell2mat(textscan(tline,'%f %*d %*s %f',1));
        if isfield(datastruct,'TAKEOFF')
            datastruct.TAKEOFF = [datastruct.TAKEOFF;TAKEOFF];
        else
           datastruct.TAKEOFF = TAKEOFF;
        end 
        
    elseif strfind(tline,'WEATHER')
        WEATHERTemp =textscan(tline,'%f %*d %*s %f %f %f %f',1);
        if isempty(WEATHERTemp{end})
            WEATHER = cell2mat(WEATHERTemp(1:end-1));
        else
            WEATHER = cell2mat(WEATHERTemp);
        end
        if isfield(datastruct,'WEATHER')
            datastruct.WEATHER = [datastruct.WEATHER;WEATHER];
        else
            datastruct.WEATHER = WEATHER;
        end
        
    elseif ~isempty(strfind(tline,'WIND_INFO'))&& isempty(strfind(tline,'RET'))
        WIND_INFO= cell2mat(textscan(tline,'%f %*d %*s %f %f %f %f %f',1));
        if isfield(datastruct,'WIND_INFO')
            datastruct.WIND_INFO = [datastruct.WIND_INFO;WIND_INFO];
        else
            datastruct.WIND_INFO = WIND_INFO;
        end 
    elseif ~isempty(strfind(tline,'WIND_INFO'))&& ~isempty(strfind(tline,'RET'))
        WIND_INFO_RET= cell2mat(textscan(tline,'%f %*d %*s %f %f %f',1));
        if isfield(datastruct,'WIND_INFO_RET')
            datastruct.WIND_INFO_RET = [datastruct.WIND_INFO_RET;WIND_INFO_RET];
        else
            datastruct.WIND_INFO_RET = WIND_INFO_RET;
        end         
        
    elseif strfind(tline,'WP_MOVED')
        WP_MOVED= cell2mat(textscan(tline,'%f %*d %*s %f %f %f %f %f',1));
        if isfield(datastruct,'WP_MOVED')
            datastruct.WP_MOVED = [datastruct.WP_MOVED;WP_MOVED];
        else
            datastruct.WP_MOVED = WP_MOVED;
        end
        
    end
    
end

